import{s as pe,n as ue,o as ge}from"../chunks/scheduler.37c15a92.js";import{S as he,i as fe,g as h,s as i,r as s,A as ce,h as f,f as n,c as r,j as oe,u as o,x as S,k as le,y as de,a,v as l,d as m,t as p,w as u}from"../chunks/index.7cb9c9b8.js";import{Q as me}from"../chunks/Question.f95a37ca.js";import{H,E as we}from"../chunks/EditOnGithub.858acfec.js";function $e(ee){let g,C,M,E,c,z,d,te='The best way to learn and <a href="https://www.coursera.org/lecture/learning-how-to-learn/illusions-of-competence-BuFzf" rel="nofollow">to avoid the illusion of competence</a> <strong>is to test yourself.</strong> This will help you to find <strong>where you need to reinforce your knowledge</strong>.',P,w,j,$,ne="<summary>Solution</summary> <p><em>Tabular methods</em> is a type of problem in which the state and actions spaces are small enough to approximate value functions to be <strong>represented as arrays and tables</strong>. For instance, <strong>Q-Learning is a tabular method</strong> since we use a table to represent the state, and action value pairs.</p>",F,y,I,b,U,v,G,x,ae=`<summary>Solution</summary> <p>We stack frames together because it helps us <strong>handle the problem of temporal limitation</strong>: one frame is not enough to capture temporal information.
For instance, in pong, our agent <strong>will be unable to know the ball direction if it gets only one frame</strong>.</p> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation.jpg" alt="Temporal limitation"/> <img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit4/temporal-limitation-2.jpg" alt="Temporal limitation"/>`,B,Q,R,q,N,T,O,L,ie=`<summary>Solution</summary> <p><strong>1. Make more efficient use of the experiences during the training</strong></p> <p>Usually, in online reinforcement learning, the agent interacts in the environment, gets experiences (state, action, reward, and next state), learns from them (updates the neural network), and discards them. This is not efficient.
But, with experience replay, <strong>we create a replay buffer that saves experience samples that we can reuse during the training</strong>.</p> <p><strong>2. Avoid forgetting previous experiences and reduce the correlation between experiences</strong></p> <p>The problem we get if we give sequential samples of experiences to our neural network is that it <strong>tends to forget the previous experiences as it overwrites new experiences</strong>. For instance, if we are in the first level and then the second, which is different, our agent can forget how to behave and play in the first level.</p>`,J,_,K,k,re="<summary>Solution</summary> <p>When we compute the Q target, we use two networks to decouple the action selection from the target Q value generation. We:</p> <ul><li><p>Use our <em>DQN network</em> to <strong>select the best action to take for the next state</strong> (the action with the highest Q value).</p></li> <li><p>Use our <em>Target network</em> to calculate <strong>the target Q value of taking that action at the next state</strong>.</p></li></ul>",V,W,se="Congrats on finishing this Quiz 🥳, if you missed some elements, take time to read again the chapter to reinforce (😏) your knowledge.",X,D,Y,A,Z;return c=new H({props:{title:"Quiz",local:"quiz",headingTag:"h1"}}),w=new H({props:{title:"Q1: We mentioned Q Learning is a tabular method. What are tabular methods?",local:"q1-we-mentioned-q-learning-is-a-tabular-method-what-are-tabular-methods",headingTag:"h3"}}),y=new H({props:{title:"Q2: Why can’t we use a classical Q-Learning to solve an Atari Game?",local:"q2-why-cant-we-use-a-classical-q-learning-to-solve-an-atari-game",headingTag:"h3"}}),b=new me({props:{choices:[{text:"Atari environments are too fast for Q-Learning",explain:""},{text:"Atari environments have a big observation space. So creating an updating the Q-Table would not be efficient",explain:"",correct:!0}]}}),v=new H({props:{title:"Q3: Why do we stack four frames together when we use frames as input in Deep Q-Learning?",local:"q3-why-do-we-stack-four-frames-together-when-we-use-frames-as-input-in-deep-q-learning",headingTag:"h3"}}),Q=new H({props:{title:"Q4: What are the two phases of Deep Q-Learning?",local:"q4-what-are-the-two-phases-of-deep-q-learning",headingTag:"h3"}}),q=new me({props:{choices:[{text:"Sampling",explain:"We perform actions and store the observed experiences tuples in a replay memory.",correct:!0},{text:"Shuffling",explain:""},{text:"Reranking",explain:""},{text:"Training",explain:"We select the small batch of tuple randomly and learn from it using a gradient descent update step.",correct:!0}]}}),T=new H({props:{title:"Q5: Why do we create a replay memory in Deep Q-Learning?",local:"q5-why-do-we-create-a-replay-memory-in-deep-q-learning",headingTag:"h3"}}),_=new H({props:{title:"Q6: How do we use Double Deep Q-Learning?",local:"q6-how-do-we-use-double-deep-q-learning",headingTag:"h3"}}),D=new we({props:{source:"https://github.com/huggingface/deep-rl-class/blob/main/units/en/unit3/quiz.mdx"}}),{c(){g=h("meta"),C=i(),M=h("p"),E=i(),s(c.$$.fragment),z=i(),d=h("p"),d.innerHTML=te,P=i(),s(w.$$.fragment),j=i(),$=h("details"),$.innerHTML=ne,F=i(),s(y.$$.fragment),I=i(),s(b.$$.fragment),U=i(),s(v.$$.fragment),G=i(),x=h("details"),x.innerHTML=ae,B=i(),s(Q.$$.fragment),R=i(),s(q.$$.fragment),N=i(),s(T.$$.fragment),O=i(),L=h("details"),L.innerHTML=ie,J=i(),s(_.$$.fragment),K=i(),k=h("details"),k.innerHTML=re,V=i(),W=h("p"),W.textContent=se,X=i(),s(D.$$.fragment),Y=i(),A=h("p"),this.h()},l(e){const t=ce("svelte-u9bgzb",document.head);g=f(t,"META",{name:!0,content:!0}),t.forEach(n),C=r(e),M=f(e,"P",{}),oe(M).forEach(n),E=r(e),o(c.$$.fragment,e),z=r(e),d=f(e,"P",{"data-svelte-h":!0}),S(d)!=="svelte-rgmkvd"&&(d.innerHTML=te),P=r(e),o(w.$$.fragment,e),j=r(e),$=f(e,"DETAILS",{"data-svelte-h":!0}),S($)!=="svelte-gsebop"&&($.innerHTML=ne),F=r(e),o(y.$$.fragment,e),I=r(e),o(b.$$.fragment,e),U=r(e),o(v.$$.fragment,e),G=r(e),x=f(e,"DETAILS",{"data-svelte-h":!0}),S(x)!=="svelte-nzbq54"&&(x.innerHTML=ae),B=r(e),o(Q.$$.fragment,e),R=r(e),o(q.$$.fragment,e),N=r(e),o(T.$$.fragment,e),O=r(e),L=f(e,"DETAILS",{"data-svelte-h":!0}),S(L)!=="svelte-10rxkt3"&&(L.innerHTML=ie),J=r(e),o(_.$$.fragment,e),K=r(e),k=f(e,"DETAILS",{"data-svelte-h":!0}),S(k)!=="svelte-1u03gxl"&&(k.innerHTML=re),V=r(e),W=f(e,"P",{"data-svelte-h":!0}),S(W)!=="svelte-rjct7w"&&(W.textContent=se),X=r(e),o(D.$$.fragment,e),Y=r(e),A=f(e,"P",{}),oe(A).forEach(n),this.h()},h(){le(g,"name","hf:doc:metadata"),le(g,"content",ye)},m(e,t){de(document.head,g),a(e,C,t),a(e,M,t),a(e,E,t),l(c,e,t),a(e,z,t),a(e,d,t),a(e,P,t),l(w,e,t),a(e,j,t),a(e,$,t),a(e,F,t),l(y,e,t),a(e,I,t),l(b,e,t),a(e,U,t),l(v,e,t),a(e,G,t),a(e,x,t),a(e,B,t),l(Q,e,t),a(e,R,t),l(q,e,t),a(e,N,t),l(T,e,t),a(e,O,t),a(e,L,t),a(e,J,t),l(_,e,t),a(e,K,t),a(e,k,t),a(e,V,t),a(e,W,t),a(e,X,t),l(D,e,t),a(e,Y,t),a(e,A,t),Z=!0},p:ue,i(e){Z||(m(c.$$.fragment,e),m(w.$$.fragment,e),m(y.$$.fragment,e),m(b.$$.fragment,e),m(v.$$.fragment,e),m(Q.$$.fragment,e),m(q.$$.fragment,e),m(T.$$.fragment,e),m(_.$$.fragment,e),m(D.$$.fragment,e),Z=!0)},o(e){p(c.$$.fragment,e),p(w.$$.fragment,e),p(y.$$.fragment,e),p(b.$$.fragment,e),p(v.$$.fragment,e),p(Q.$$.fragment,e),p(q.$$.fragment,e),p(T.$$.fragment,e),p(_.$$.fragment,e),p(D.$$.fragment,e),Z=!1},d(e){e&&(n(C),n(M),n(E),n(z),n(d),n(P),n(j),n($),n(F),n(I),n(U),n(G),n(x),n(B),n(R),n(N),n(O),n(L),n(J),n(K),n(k),n(V),n(W),n(X),n(Y),n(A)),n(g),u(c,e),u(w,e),u(y,e),u(b,e),u(v,e),u(Q,e),u(q,e),u(T,e),u(_,e),u(D,e)}}}const ye='{"title":"Quiz","local":"quiz","sections":[{"title":"Q1: We mentioned Q Learning is a tabular method. What are tabular methods?","local":"q1-we-mentioned-q-learning-is-a-tabular-method-what-are-tabular-methods","sections":[],"depth":3},{"title":"Q2: Why can’t we use a classical Q-Learning to solve an Atari Game?","local":"q2-why-cant-we-use-a-classical-q-learning-to-solve-an-atari-game","sections":[],"depth":3},{"title":"Q3: Why do we stack four frames together when we use frames as input in Deep Q-Learning?","local":"q3-why-do-we-stack-four-frames-together-when-we-use-frames-as-input-in-deep-q-learning","sections":[],"depth":3},{"title":"Q4: What are the two phases of Deep Q-Learning?","local":"q4-what-are-the-two-phases-of-deep-q-learning","sections":[],"depth":3},{"title":"Q5: Why do we create a replay memory in Deep Q-Learning?","local":"q5-why-do-we-create-a-replay-memory-in-deep-q-learning","sections":[],"depth":3},{"title":"Q6: How do we use Double Deep Q-Learning?","local":"q6-how-do-we-use-double-deep-q-learning","sections":[],"depth":3}],"depth":1}';function be(ee){return ge(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Te extends he{constructor(g){super(),fe(this,g,be,$e,pe,{})}}export{Te as component};
